﻿#############################################################
## Systemwalker Centric Manager AR連携サンプル
## Copyright 2015 FUJITSU LIMITED
#############################################################
require 'cgi'
require 'csv'
require 'rexml/document'

#エラー出力
def error_cgi
	print "Content-Type:text/html;charset=UTF-8\n\n"
	print "<br />*** CGI Error List ***<br />"
	print "#{CGI.escapeHTML($!.inspect)}<br />"
	$@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

begin

#CGIオブジェクトを作成する
cgi=CGI.new()
#HTTPヘッダーを出力する
print("Access-Control-Allow-Origin: *\n")
puts cgi.header("charset"=>"UTF-8")
ip=cgi["i"]
db=cgi["sv"]
group=cgi["g"]
host=cgi["h"]

event_log='./db/event.csv'		#2日分のトラブルログ
event_csv='./db/eventlog.csv'	#2日分のイベントログ
error_log='./db/log/cgierr.log'

#イベント管理用のXMLファイルを作成

#############################################################
## CMGR DBからイベントメッセージをCSVファイルに出力する
#############################################################
d=Date.today
d=d-1
str=d.strftime("%y%m%d000000")
cmd="opmtrcsv -st "+str+" -o "+event_csv+" -l IpAddr Status"
pid = spawn(cmd,STDERR=>error_log)
Process.waitpid pid

#古いトラブルログファイルを削除する
if File.exist?(event_log) then
	File.delete(event_log)
end
	
csvdata=[]
rows=[]
cells=[]
outData="";

#############################################################
## イベントメッセージ用CSVファイルからイベントログを読み込む
#############################################################

File.open(event_csv,"r:sjis") do |csvdb|
	csvdata=csvdb.readlines
end
	
log2=File.open(event_log,"w:utf-8")
	
############################################################################
## イベントメッセージからトラブルログを抜き出して保存する
############################################################################
for data in csvdata do
	if(data=="") then
		break
	end   
	rows=data.chomp
	cells=rows.split(',')
	str=cells[2][1..cells[2].size-2]
	if(str=="Trouble") then
		str=cells[8][1..cells[8].size-2]
		str.gsub!("<","&lt;")
		str.gsub!(">","&gt;")
		cells[8][1..cells[8].size-2]=str
		log2.puts cells.join(",")
	end
end

log2.close

logs=[]
CSV.open(event_log,"r:utf-8") do |io|
  logs=io.readlines
end

outdata=""
i=logs.length-1
j=0
until i<0 do
	cells=logs[i]
	str=cells[7]
	i=i-1
	if(ip==str || host==str) then
		if(cells[2] == "Trouble") then
			j=j+1
			eventNo=cells[0]
			eventType=cells[3]
			eventTime=cells[4]
			eventHost=cells[7]
			eventMsg=cells[8]
			eventPerson=cells[9]
			eventMemo=cells[10]
			eventIp=cells[13]
			outdata+='evt,'+eventNo+','+eventType+','+eventTime+','+eventHost+','+eventIp+','+eventPerson+','+eventMemo+',"'+eventMsg+"\"\n"
		end
	end
end

if(outdata=="") then
	print("nf");
else	  
	print(j,',',group,',',db,',',host,",,,\n",outdata)
end

exit(0)  

rescue
  error_cgi
end
 
