﻿#############################################################
## Systemwalker Centric Manager AR連携サンプル
## Copyright 2015 FUJITSU LIMITED
#############################################################
require 'cgi'
require 'csv'
#エラー出力
def error_cgi
  print "Content-Type:text/html;charset=UTF-8\n\n"
  print "<br />*** CGI Error List ***<br />"
  print "#{CGI.escapeHTML($!.inspect)}<br />"
    $@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

begin

#CGIオブジェクトを作成する
cgi=CGI.new()
#HTTPヘッダーを出力する
print("Access-Control-Allow-Origin: *\n")
puts cgi.header("charset"=>"UTF-8")

ip=cgi['i']
own=cgi['own']
mgrip=""

if own=='true' then
	mgrip=ip
	ip="OWN"
end

inventory_file="./db/inventory/h_"+ip+".csv"
error_log='./db/log/cgierr.log'

#インベントリファイルは削除しておく
if File.exist?(inventory_file) then
	File.delete(inventory_file)
end

cmd = "drmscsv -a merge -k inv -o "+inventory_file+" -s "+ip+" -i hard"
pid = spawn(cmd,STDERR=>error_log)
Process.waitpid pid

#運用管理サーバ用の処理
#インベントリファイルの存在確認。
if not File.exist?(inventory_file) then
	inventory_file="./db/inventory/h_"+mgrip+".csv"
	cmd = "drmscsv -a merge -k inv -o "+inventory_file+" -s "+mgrip+" -i hard"
	pid = spawn(cmd,STDERR=>error_log)
	Process.waitpid pid
end

outdata = ""
if File.exist?(inventory_file) then
	inventory=[]
	CSV.open(inventory_file,"r") do |io|
		inventory=io.readlines
	end
	cells=inventory[1]
	if (cells[2]!=nil)   then invDate=cells[2]        else invDate=""      end
	if (cells[83]!=nil)  then invServer=cells[83]     else invServer=""    end
	if (cells[84]!=nil)  then invIp=cells[84]         else invIp=""        end
	if (cells[105]!=nil) then invAttr=cells[105]      else invAttr=""      end
	if (cells[8]!=nil)   then invBios=cells[8]        else invBios=""      end
	if (cells[113]!=nil) then invComputer=cells[113]  else invComputer=""  end
	if (cells[115]!=nil) then invDomain=cells[115]    else invDomain=""    end
	if (cells[9]!=nil)   then invCpu=cells[9]         else invCpu=""       end
	if (cells[106]!=nil) then invCpuNum=cells[106]    else invCpuNum=""    end
	if (cells[120]!=nil) then invClock=cells[120]     else invClock=""     end
	if (cells[121]!=nil) then invCpuDetail=cells[121] else invCpuDetail="" end
	if (cells[10]!=nil)  then invMem=cells[10]        else invMem=""       end
	if (cells[158]!=nil) then invSwap=cells[158]      else invSwap=""      end
	if (cells[48]!=nil)  then invDisk=cells[48]       else invDisk=""      end
	if (cells[75]!=nil)  then invDiskFree=cells[75]   else invDiskFree=""  end
	if (cells[153]!=nil) then invBendar=cells[153]    else invBendar=""    end
	if (cells[154]!=nil) then invModel=cells[154]     else invModel=""     end
	if (cells[155]!=nil) then invSirNo=cells[155]     else invSirNo=""     end

	if (invDate.include?(","))      then invDate      = invDate.gsub(/\,/," ") end
	if (invServer.include?(","))    then invServer    = invServer.gsub(/\,/," ") end
	if (invIp.include?(","))        then invIp        = invIp.gsub(/\,/," ") end
	if (invAttr.include?(","))      then invAttr      = invAttr.gsub(/\,/," ") end
	if (invBios.include?(","))      then invBios      = invBios.gsub(/\,/," ") end
	if (invComputer.include?(","))  then invComputer  = invComputer.gsub(/\,/," ") end
	if (invDomain.include?(","))    then invDomain    = invDomain.gsub(/\,/," ") end
	if (invCpu.include?(","))       then invCpu       = invCpu.gsub(/\,/," ") end
	if (invCpuDetail.include?(",")) then invCpuDetail = invCpuDetail.gsub(/\,/," ") end
	if (invMem.include?(","))       then invMem       = invMem.gsub(/\,/," ") end
	if (invSwap.include?(","))      then invSwap      = invSwap.gsub(/\,/," ") end
	if (invDisk.include?(","))      then invDisk      = invDisk.gsub(/\,/," ") end
	if (invDiskFree.include?(","))  then invDiskFree  = invDiskFree.gsub(/\,/," ") end
	if (invBendar.include?(","))    then invBendar    = invBendar.gsub(/\,/," ") end
	if (invModel.include?(","))     then invModel     = invModel.gsub(/\,/," ") end
	if (invSirNo.include?(","))     then invSirNo     = invSirNo.gsub(/\,/," ") end

	outdata+='"'+invDate+'","'+
				 invServer+'","'+
				 invIp+'","'+
				 invAttr+'","'+
				 invBios+'","'+
				 invComputer+'","'+
				 invDomain+'","'+
				 invCpu+'","'+
				 invCpuNum+'","'+
				 invClock+'","'+
				 invCpuDetail+'","'+
				 invMem+'","'+
				 invSwap+'","'+
				 invDisk+'","'+
				 invDiskFree+'","'+
				 invBendar+'","'+
				 invModel+'","'+
				 invSirNo+'"'+"\n" 
else
	outdata = "nf"
end

print(outdata)


rescue
  error_cgi
end
 
