﻿#############################################################
## Systemwalker Centric Manager AR連携サンプル
## Copyright 2015 FUJITSU LIMITED
#############################################################
require 'cgi' 
require 'kconv'
require 'rexml/document'
require 'strscan'

#エラー出力
def error_cgi
	print "Content-Type:text/html;charset=UTF-8\n\n"
	print "<br />*** CGI Error List ***<br />"
	print "#{CGI.escapeHTML($!.inspect)}<br />"
	$@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

begin

#CGIオブジェクトを作成する
cgi=CGI.new()
#HTTPヘッダーを出力する
print("Access-Control-Allow-Origin: *\n")
puts cgi.header("charset"=>"UTF-8")

#パラメタを取得する
host=cgi["h"]

#iniファイルからCMGRパス読み込み
ini_file="./db/property.ini"
pn_cmgr_path="cmgr_path"

inidata=open(ini_file)
while line=inidata.gets
	s=StringScanner.new(line)
	if s.scan(/(\w+)\s*=\s*(["'])?([^\n]+)\2/) then
		if(s[1]==pn_cmgr_path) then
			cmgr_path=s[3]
		end
	end
end
inidata.close

################################################################################
## 性能情報を取得する
################################################################################
cmd_path=cmgr_path+"mpnetmgr/bin/"

file_NTL_Cpu=cmgr_path+"mpnetmgr/miblog/"+host+"/mpCpuRateAve.1.NTL"
file_NTL_Mem=cmgr_path+"mpnetmgr/miblog/"+host+"/mpMemUsageAve.1.NTL"
file_NTL_Disk=cmgr_path+"mpnetmgr/miblog/"+host+"/mpDiskUsageAve.1.NTL"

file_CSV_Cpu="./db/perf/"+host+"_mpCpuRateAve.1.csv"
file_CSV_Mem="./db/perf/"+host+"_mpMemUsageAve.1.csv"
file_CSV_Disk="./db/perf/"+host+"_mpDiskUsageAve.1.csv"

file_error_Cpu_log="./db/log/"+host+"_mpnmmibconv_error_cpu.log"
file_error_Mem_log="./db/log/"+host+"_mpnmmibconv_error_mem.log"
file_error_Disk_log="./db/log/"+host+"_mpnmmibconv_error_disk.log"

if File.exist?(file_NTL_Cpu) then
	cmd=cmd_path+"mpnmmibconv "+file_NTL_Cpu+" "+file_CSV_Cpu
	pid = spawn(cmd,STDERR=>file_error_Cpu_log)
	Process.waitpid pid
else
	print("nf")
	exit(-1)
end

if File.exist?(file_NTL_Mem) then
	cmd=cmd_path+"mpnmmibconv "+file_NTL_Mem+" "+file_CSV_Mem
	pid = spawn(cmd,STDERR=>file_error_Mem_log)
	Process.waitpid pid
else
	print("nf")
	exit(-1)
end

if File.exist?(file_NTL_Disk) then
	cmd=cmd_path+"mpnmmibconv "+file_NTL_Disk+" "+file_CSV_Disk
	pid = spawn(cmd,STDERR=>file_error_Disk_log)
	Process.waitpid pid
else
	print("nf")
	exit(-1)
end

csvdata_Cpu=[]
csvdata_Mem=[]
csvdata_Disk=[]
cells=[]
outdata="";
outdata1="";

#############################################################
## CPU使用率、メモリ使用率、ディスク使用率を取得する
#############################################################

if File.exist?(file_CSV_Cpu) then
	File.open(file_CSV_Cpu,"r:sjis") do |csvdb|
		csvdata_Cpu=csvdb.readlines
	end
else
	print("nf")
	exit(-1)
end
if File.exist?(file_CSV_Mem) then
	File.open(file_CSV_Mem,"r:sjis") do |csvdb|
		csvdata_Mem=csvdb.readlines
	end
else
	print("nf")
	exit(-1)
end
if File.exist?(file_CSV_Disk) then
	File.open(file_CSV_Disk,"r:sjis") do |csvdb|
		csvdata_Disk=csvdb.readlines
	end
else
	print("nf")
	exit(-1)
end
	
i=csvdata_Cpu.length-1
until i<0 do
	rows=csvdata_Cpu[i].chomp
	cells=rows.split(',')
	outdata+=cells[0]+","+cells[1]+","+cells[5]+","
	rows=csvdata_Mem[i].chomp
	cells=rows.split(',')
	outdata+=cells[5]+","
	rows=csvdata_Disk[i].chomp
	cells=rows.split(',')
	outdata+=cells[5]+"\n"
	i-=1
end

print(cells[2],",",cells[0],",",csvdata_Cpu.length,"\n",outdata)

exit(0)  

rescue
	error_cgi
end
 
