#############################################################
## Systemwalker Centric Manager AR連携サンプル
## Copyright 2015 FUJITSU LIMITED
#############################################################
#CGIライブラリをロードする
require 'cgi'
require 'rexml/document'

cgi=CGI.new()
print("Access-Control-Allow-Origin: *\n")
puts cgi.header("charset"=>"UTF-8")

#送信されたフォームの値を得る
ip=cgi["i"]
host=cgi["h"]
opt=cgi["o"]
db=cgi["sv"]
rack=cgi["g"]

#今日の日時を取得
d=Time.now
str=d.to_s
i=str.index("+")
nen=str[0..i-2]

#エラー出力
def error_cgi
  print "Content-Type:text/html;charset=UTF-8\n\n"
  print "<br />*** CGI Error List ***<br />"
  print "#{CGI.escapeHTML($!.inspect)}<br />"
    $@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

begin
log_file='./db/log/sw_ar.log'
cmd_file='./db/temp/mnt_'+host+'.csv'
xml_file='./db/server_list_'+db+'.xml'
error_log='./db/log/cgierr.log'

if(opt!="nf") then
  cmd=File.open(cmd_file,'w')
  cmd.puts '"'+ip+'","'+host+'"' 
  cmd.close
end  

cmd=""
case opt
  when "stop" then cmd="mpmonsuspend -f "+cmd_file
  when "hosyu" then cmd="mpmonsuspend -f "+cmd_file
  when "start" then cmd="mpmonresume -f "+cmd_file
end  

if(cmd!="") then
	pid = spawn(cmd,STDERR=>error_log)
	Process.waitpid pid
end

d=Time.now
str=d.to_s
i=str.index("+")
nen=str[0..i-2]

#構成情報を変更する
doc=REXML::Document.new(open(xml_file))
root=doc.root
root.elements.each{|upd|
  db_ip=upd.attributes.get_attribute('ip')
  if(db_ip.to_s==ip.to_s) then
    case opt
      when "start" then upd.attributes["status"]="0"
      when "stop" then upd.attributes["status"]="7"
      when "hosyu" then upd.attributes["status"]="6"
      when "nf" then upd.attributes["status"]="9"
    end
    break
  end
}

File.open(xml_file,"w"){|outfile|
  doc.write(outfile,0)
}

#ログを追加します
d=Time.now
str=d.to_s
i=str.index("+")
nen=str[0..i-2]

log_data=File.open(log_file,'a')

case opt
  when "stop" then log_data.puts nen+"\t"+rack+"\t"+host+"("+ip+")\t監視を抑止しました。\n"
  when "hosyu" then log_data.puts nen+"\t"+rack+"\t"+host+"("+ip+")\t監視を抑止しました。\n"
  when "start" then log_data.puts nen+"\t"+rack+"\t"+host+"("+ip+")\t監視を再開しました。\n"
end  

log_data.close

case opt
  when "stop" then print("msg,",host+"の監視を抑止しました。\n")
  when "hosyu" then print("msg,",host+"の監視を抑止しました。\n")
  when "start" then print("msg,",host+"の監視を再開しました。\n")
end  

rescue
  error_cgi
end

