﻿#############################################################
## Systemwalker Centric Manager AR連携サンプル
## Copyright 2015 FUJITSU LIMITED
#############################################################
#CGIライブラリをロードする
require 'cgi'
require 'date'
require 'kconv'
require 'rexml/document'

cgi=CGI.new()
print("Access-Control-Allow-Origin: *\n")
puts cgi.header("charset"=>"UTF-8")

#送信されたフォームの値を得る
db=cgi["sv"]

db_xml='./db/server_list_'+db+'.xml'
db_csv='./db/eventlog.csv'
db_event='./db/event.csv'
error_log='./db/log/cgierr.log'

#エラー出力
def error_cgi
	print "Content-Type:text/html;charset=UTF-8\n\n"
	print "<br />*** CGI Error List ***<br />"
	print "#{CGI.escapeHTML($!.inspect)}<br />"
	$@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

begin

##########################################################
## サーバ定義用のDBを確認する
##########################################################

if !File.exist?(db_xml) then
	print("ndb")
	exit(-1)
end  


##########################################################
## opmtrcsvコマンドにより前日からのイベント情報を取得する
##########################################################
d=Date.today
d=d-1
str=d.strftime("%y%m%d000000")
cmd="opmtrcsv -st "+str+" -o "+db_csv+" -l IpAddr Status"
pid = spawn(cmd,STDERR=>error_log)
Process.waitpid pid

if File.exist?(db_event) then
	File.delete(db_event)
end

csvdata=[]
rows=[]
cells=[]
outData="";

###########################################################
## イベントメッセージ用CSVファイルをオープンする
###########################################################

File.open(db_csv,"r:sjis") do |csvdb|
	csvdata=csvdb.readlines
end

###########################################################
## 構成情報定義ファイルからサーバ情報を取り出す
###########################################################
i=0;j=0;
log2=File.open(db_event,"w:utf-8")
doc=REXML::Document.new File.new(db_xml)
root=doc.root
groupname=root.attributes.get_attribute("name").value
comment=root.attributes.get_attribute("comment").value

root.elements.each{|server|
	num=server.attributes.get_attribute("seq").value
	ip=server.attributes.get_attribute("ip").value
	name=server.attributes.get_attribute("name").value
	status=server.attributes.get_attribute("status").value
	place=server.attributes.get_attribute("place").value
	if(ip!="") then
		if(name=="") then
			host=ip
		else
			host=name  
		end  

		############################################################################
		## サーバに対するイベント発生状況を確認する
		############################################################################
		event=status
		for data in csvdata do
			if(data=="") then
				break
			end   
			rows=data.chomp
			cells=rows.split(',')
			str=cells[7][1..cells[7].size-2]
			if(ip==str || host==str) then
				str=cells[2][1..cells[2].size-2]
				if(str=="Trouble") then
					event="ng"
				end	
				log2.puts rows
			end
		end
		outData+=num+","+event+","+host+","+ip+","+status+","+place+"\n"
		if(event=="ng") then j+=1; end
		i+=1;
	else	
		outData+=num+",,,,,\n"
	end	
}

log2.close

###################################################################
## データをクライアントに転送する
###################################################################
print(groupname,",",j,",",i,",",comment,"\n",outData)

rescue
  error_cgi
end

