#############################################################
## Systemwalker Centric Manager AR連携サンプル
## Copyright 2015 FUJITSU LIMITED
#############################################################
require 'cgi'
require 'csv'
#エラー出力
def error_cgi
  print "Content-Type:text/html;charset=UTF-8\n\n"
  print "<br />*** CGI Error List ***<br />"
  print "#{CGI.escapeHTML($!.inspect)}<br />"
    $@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

begin

#CGIオブジェクトを作成する
cgi=CGI.new()
#HTTPヘッダーを出力する
print("Access-Control-Allow-Origin: *\n")
puts cgi.header("charset"=>"UTF-8")

ip=cgi['i']
own=cgi['own']
mgrip=""

if own=='true' then
	mgrip=ip
	ip="OWN"
end

inventory_file="./db/inventory/s_"+ip+".csv"
error_log='./db/log/cgierr.log'

#インベントリファイルは削除しておく
if File.exist?(inventory_file) then
	File.delete(inventory_file)
end

cmd = "drmscsv -a merge -k inv -o "+inventory_file+" -s "+ip+" -i soft"
pid = spawn(cmd,STDERR=>error_log)
Process.waitpid pid

#運用管理サーバ用の処理
#インベントリファイルの存在確認。
if not File.exist?(inventory_file) then
	inventory_file="./db/inventory/h_"+mgrip+".csv"
	cmd = "drmscsv -a merge -k inv -o "+inventory_file+" -s "+mgrip+" -i hard"
	pid = spawn(cmd,STDERR=>error_log)
	Process.waitpid pid
end

if File.exist?(inventory_file) then
	inventory=[]
	CSV.open(inventory_file,"r") do |io|
		inventory=io.readlines
	end
	outdata=""	  
	for i in 1..inventory.length-1 do
		cells=inventory[i]
		invDate=cells[2]
		invAppli=cells[8].encode("utf-8")
		if (invDate.include?(","))  then invDate  = invDate.gsub(/\,/," ") end
		if (invAppli.include?(",")) then invAppli = invAppli.gsub(/\,/," ") end
		outdata += '"'+invDate+'","'+invAppli+'"'+"\n"
	end
else
	outdata = "nf"
end

print(outdata) 

rescue
  error_cgi
end
 
